/* Beispiel fr komplexere Struktur und deren Zugriff von Eiffel */

#include "c_struct.h"

void c_print_name (const name_and_age *an_example){
  assert(an_example != NULL);
  (void) printf("Name: %s\n", c_get_name(an_example));
}

void c_print_age (const name_and_age *an_example){
  assert(an_example != NULL);
  (void) printf("Alter: %hu\n", c_get_age(an_example));
}


name_and_age* c_new_name_and_age_struct(void){
  name_and_age *Result;
  /* error-handling on the Eiffel-side */
  Result = malloc(sizeof(*Result));
  
  return Result;
}

void c_set_name(name_and_age *an_example, const char* a_name){
  assert(an_example != NULL && a_name != NULL);
  strcpy(an_example->name, a_name);
}


void c_set_age(name_and_age *an_example, unsigned short an_age){
  assert(an_example != NULL);
  an_example->age = an_age;
}

char* c_get_name(const name_and_age *an_example){
  assert(an_example != NULL);
  return(an_example->name);
}

unsigned short c_get_age(const name_and_age *an_example){
  assert(an_example != NULL);
  return(an_example->age);
}
  
  
void c_free_name_and_age (name_and_age *an_example){
  assert(an_example != NULL);
  free(an_example);
}
	
	
	
	
#ifdef RUN_TEST
	int main(void){
	  
	  name_and_age *t;
	  
	  t = c_new_name_and_age_struct();
	  c_set_name(t, "Friedrich");
	  c_print_name(t);
	  c_set_age(t, 33);
	  c_print_age(t);
	  printf ("You're %s and you are %hd years old\n",
			  c_get_name(t),
			  c_get_age(t));
	  c_free_name_and_age(t);
	  return 0;
	}
	  
#endif /* ifdef RUN_TEST */
