class C_STRUCT
inherit 
	MEMORY
		undefine 
			copy
		redefine dispose
		end;
	C_STRUCT_WRAPPER
		export {NONE} all;
		undefine copy
		end;
	UNCOPYABLE

creation make
	
feature
   
   make (a_name: STRING; an_age: INTEGER) is 
	  require
		 valid_name: a_name /= Void and then a_name.count < 30;
		 valid_age: (an_age >= min_age) and then (an_age <= max_age);
		 -- Methusalems Zeiten sind vorbie ;)
	  do
		 c_pointer := c_new_name_and_age_struct;
		 if c_pointer /= default_pointer then
			-- malloc hat hingehauen
			set_name(a_name);
			set_age(an_age);
		 else
			-- malloc ging schief, crashing;-)
			-- Ganz im Sinne von 
			-- 'Can't happen or 
			--  /* NOTREACHED */ or
			-- Real Program Dump Core 
			-- ftp://ftp.cs.toronto.edu/doc/programming/canthappen.PS
			crash;
			-- wirklich empfehlenswert?
		 end; -- if
	  end; -- make
   

   min_age: INTEGER is 0;
   max_age: INTEGER is 255;
    -- sollte langen
   

   name: STRING is
	  local
		 ptr: POINTER;
	  do
		 ptr := c_get_name(c_pointer);
		 !!Result.from_external(ptr);
	  end;

   age: INTEGER is
	  do
		 Result := c_get_age(c_pointer);
	  ensure
		 age_in_bound: (Result >= min_age) and then (Result <= max_age);
	  end;
   
   set_name(a_name: STRING) is
	  require
		 valid_name: a_name /= Void and then a_name.count < 30;
	  do
		 c_set_name(c_pointer, a_name);
	  ensure
		 name_set: name.is_equal(a_name);
	  end;
   
   set_age (an_age: INTEGER) is
	  require
		 valid_age: (an_age >= min_age) and then (an_age <= max_age);
	  do
		 c_set_age(c_pointer, an_age);
	  end;
   
   print_name is
	  do
		 c_print_name(c_pointer);
	  end;
   
   print_age is
	  do
		 c_print_age(c_pointer);
	  end;
   
   
   dispose is 
	  do
		 c_free_name_and_age(c_pointer);
		 c_pointer := default_pointer;
	  ensure
		 c_pointer_invalid: c_pointer = default_pointer;
	  end;
   
   
feature {NONE}
	c_pointer: POINTER;

end -- class C_STRUCT
