%{
class COUNT_WORDS
           
inherit
   YY_COMPRESSED_SCANNER_SKELETON
      rename
         make_with_file as mwf,
         make as make_yy_bla -- umbenennen wegen der 
                             -- Methode make dieser Klasse
      redefine
         terminate 
      end;
   KL_SHARED_STANDARD_FILES
      export 
         {NONE} all
      end
      
      
creation
   make
  
%}

%option outfile="count_words.e"

%%
[ \t\n\r]+        -- ignore
[^ \t\n\r]+       run

<<EOF>>             terminate

%%

feature

    dict: DS_HASH_TABLE[INTEGER, STRING];
    buffer: STRING;
       
    make  is
        local
            a_file: like INPUT_STREAM_TYPE
        do
            a_file := INPUT_STREAM_.make_file_open_read(Arguments.argument(1));
            if INPUT_STREAM_.is_open_read (a_file) then
                mwf(a_file)
                reset
                !!dict.make_equal(196123);
                scan
                INPUT_STREAM_.close(a_file);
            end;
        end;
    
     run is
        local
            act_int: INTEGER;
        do
            if dict.has(text) then
              dict.replace((dict.item(text)+ 1,text);
            else
                dict.put(1, text);
            end; -- if
        end; -- run
    
      terminate is
        local
            i: INTEGER;
            ht_it: DS_HASH_TABLE_CURSOR[INTEGER, STRING]
        do
            ht_it := dict.new_cursor;
            from ht_it.start
            until ht_it.off
            loop
                std.output.put_integer(ht_it.item);
                std.output.put_string(": ")
                std.output.put_string(ht_it.key);
                std.output.put_character('%N');
                ht_it.forth;
            end;
            last_token := 0;
        end
    
end -- class COUNT_WORDS
